<?php
/************************************************************************
* Script:     TegoNuke(tm) ShortLinks
* Version:    1.0
* Author:     Rob Herder (aka: montego) of http://montegoscripts.com
* Contact:    montego@montegoscripts.com
* Copyright:  Copyright  2006 by Montego Scripts
* License:    GNU/GPL (see provided LICENSE.txt file)
************************************************************************/
//GT-NExtGEn 0.5 by Bill Murrin (Audioslaved) http://gt.audioslaved.com (c) 2004
//Original Nukecops GoogleTap done by NukeCops (http://www.nukecops.com)

if (!defined('TNSL_USE_SHORTLINKS')) { die('Access Denied'); }

//Configuration settings for GoogleTap/ShortURLs
$tnsl_sGTFileDir = 'ShortLinks';     //Name of Directory for GoogleTap Files. Should be located in root path with mainfile.php.
$tnsl_asGTFilePath = array();       //<-- Do NOT Touch!
$tnsl_bDebugMode = (is_admin($admin) && isset($tnsl_bDebugShortLinks) && $tnsl_bDebugShortLinks) ? TRUE : FALSE;  //<-- Do NOT Touch!
//End of Configuration Options

function tnsl_fPageTapStart() {
	global $prefix, $db, $admin, $tnsl_bDebugMode, $tnsl_sGTFileDir;
	//GT-NExtGEn 0.5 by Bill Murrin (Audioslaved) http://gt.audioslaved.com (c) 2004
	//GT-NExtGEn Header Code --- nextGenHead Variable
	//Modified by montego from http://montegoscripts.com for RavenNUke76 and TegoNuke(tm) ShortLinks
	$asGTFilePath = array();
	$sGTFilePath = '';

	if ($tnsl_bDebugMode) { echo '[nextGenFunction] = Present In Header<br />'; }

	if(isset($_REQUEST['name']) && $_REQUEST['name'] != '') {
		$nextGenName = htmlentities(stripslashes($_REQUEST['name']));
		if ($tnsl_bDebugMode) { echo '[nextGenName] = '.$nextGenName.'<br />';	}
	} else {
		$sql = 'SELECT main_module FROM '.$prefix.'_main';
		$result = $db->sql_query($sql);
		$row = $db->sql_fetchrow($result);
		$mainmod_name = $row['main_module'];
		$nextGenName = $mainmod_name; 
		if ($tnsl_bDebugMode) { echo '[nextGenName] = '.$nextGenName.' (Main Module)<br />'; }
	}

	//GT-NExtGEn Files Path --- nextGenPath Variable
	//Modified by montego from http://montegoscripts.com for RavenNUke76 and TegoNuke(tm) ShortLinks
	$sGTFilePath = $tnsl_sGTFileDir.'/GT-'.$nextGenName.'.php';
	if (@file_exists($sGTFilePath)) {
		if ($tnsl_bDebugMode) { echo '[nextGenPath] = GT File :: '.$sGTFilePath.' :: Does Exist<br />'; }
		ob_start();
		array_push($asGTFilePath, $sGTFilePath);
	} else { 
		if ($tnsl_bDebugMode) { echo '[nextGenPath] = GT File :: '.$sGTFilePath.' :: Does Not Exist!<br />'; }
	}
	//Check for PageLevel tap file
	$sGTFilePath = $tnsl_sGTFileDir.'/GTZ-PageTap.php';
	if (@file_exists($sGTFilePath)) {
		if ($tnsl_bDebugMode) { echo '[nextGenPath] = GT File :: '.$sGTFilePath.' :: Does Exist<br />'; }
		if (count($asGTFilePath) < 1) { //Only buffer the output if it has not already been done
			ob_start();
		}
		array_push($asGTFilePath, $sGTFilePath);
	} else { 
		if ($tnsl_bDebugMode) { echo '[nextGenPath] = GT File :: '.$sGTFilePath.' :: Does Not Exist!<br />'; }
	}

	return $asGTFilePath;

}

function tnsl_fPageTapFinish() {
	global $tnsl_bDebugMode;
	$asGTFilePath = $GLOBALS['tnsl_asGTFilePath'];

	//GT-NExtGEn Footer Code --- nextGenFoot Variable
	//Modified by montego from http://montegoscripts.com for RavenNUke76 and TegoNuke(tm) ShortLinks
	if ($tnsl_bDebugMode) { echo '[nextGenFunction] = Present In Footer<br />'; }

	if (count($asGTFilePath) > 0) { //We have tap files to apply
		$nextGenContent = ob_get_contents();
		tnsl_fCleanLinks($nextGenContent);
		ob_end_clean();
		foreach($asGTFilePath as $sGTFilePath) {
			if ($sGTFilePath != '') {
				if ($tnsl_bDebugMode) { echo '[nextGenPath] = Using GT File :: '.$sGTFilePath.'<br />'; }
				unset($urlin); unset($urlout);
				include_once($sGTFilePath);
				$nextGenContent = preg_replace($urlin, $urlout, $nextGenContent);
			} else {
				if ($tnsl_bDebugMode) { echo '[nextGenPath] = GT File :: '.$sGTFilePath.' :: Does Not Exist!<br />'; }
			}
		}
		echo $nextGenContent;
	}
	return;
}

function tnsl_fShortenBlockURLs($sBlockfile='', $sContents='') {
	global $tnsl_bDebugMode, $tnsl_sGTFileDir;
	if ($tnsl_bDebugMode) { echo '[nextGenFunction] = Present In Block<br />'; }

	//Determine if have "GTB File Tap" or "Recursive Tap"
	if ($sBlockfile != '') {
		$sGTBlockPath = $tnsl_sGTFileDir.'/GTB-'.$sBlockfile;
		if (@file_exists($sGTBlockPath)) { //Block has been "Tapped"
			if ($tnsl_bDebugMode) { echo '[nextGenPath] = GTB File Exists<br />'; }
			$bUseRecursiveTap = FALSE;
		} else {
			if ($tnsl_bDebugMode) { echo '[nextGenPath] = GTB File Does Not Exist<br />'; }
			$bUseRecursiveTap = TRUE;
		}
	} else {
		if ($tnsl_bDebugMode) { echo '[nextGenPath] = In HTML Block<br />'; }
		$bUseRecursiveTap = TRUE;
	}

	if (!$bUseRecursiveTap) { //Have GTB File Tap
		tnsl_fCleanLinks($sContents);
		unset($urlin); unset($urlout);
		include_once($sGTBlockPath);
		$sContents = preg_replace($urlin, $urlout, $sContents);
	} else {
		//GT-NExtGEn Block Code --- nextGenBlock Variable
		//Modified by montego from http://montegoscripts.com for RavenNUke76 and TegoNuke(tm) ShortLinks
		/* GT-NExtGEn block code does not work, so comment out for now until can fix
		preg_match_all ('(\b[name]{4}=[a-zA-Z0-9_-]*)', $nextGenContents, $getGenMatches);
		$gotGenMatches = array();
		foreach($getGenMatches[0] as $gotten) {
			$gotGenMatches[] = $gotten;
		}
		unset($getGenMatches);
		$gotGenMatches = array_unique($gotGenMatches);
		foreach($gotGenMatches as $newGenMatch) {
			$expGenMatch = explode("=", $newGenMatch);
			if(file_exists("" . $nextGenMainPath . "/GT-" . $expGenMatch[1] . ".php")) {
				$path_exists[] = 1;
				include_once("" . $nextGenMainPath . "/GT-" . $expGenMatch[1] . ".php");
				$newGenContents = preg_replace($urlin, $urlout, $nextGenContents);
			}
		}
		if (count($path_exists) < 1) {
			return $nextGenContents;
		} else {
			unset($path_exists);
			$newGenContents = preg_replace("(&(?!([a-zA-Z]{2,6}|[0-9\#]{1,6})[\;]))", "&amp;", $newGenContents);
			$newGenContents = str_replace(array("&amp;&amp;", "&amp;middot;", "&amp;nbsp;"), array("&&", "&middot;", "&nbsp;"), $newGenContents);
			return $newGenContents;
		}
		*/
	}
	return $sContents;
}

function tnsl_fCleanLinks(&$getNextGen) {
	$getNextGen = preg_replace('(&(?!([a-zA-Z]{2,6}|[0-9\#]{1,6})[\;]))', '&amp;', $getNextGen);
	$getNextGen = str_replace(array('&amp;&amp;', '&amp;middot;', '&amp;nbsp;'), array('&&', '&middot;', '&nbsp;'), $getNextGen);
	return;
}
?>
