﻿/*
 *************************************
 * Mappa Interattiva                 *
 * http://www.FlepStudio.org         *
 * © Author: Filippo Lughi           *
 * version 4.0                       *
 *************************************
 */
package
{
	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.events.ContextMenuEvent;
	import flash.ui.ContextMenu;
	import flash.ui.ContextMenuItem;
	import flash.net.navigateToURL;
	import flash.net.URLRequest;
	import flash.text.TextField;
	import flash.text.TextFormat;
	
	public class Mappa extends MovieClip
	{
		private var regioni_array:Array;
		public static var info_array:Array;
		public var citta_array:Array=new Array();
		
		private var loading_xml:LoadingXML;
		
		private var maxDepth:int=19;
		private var id:Number;
		private var startScaleX:Number;
		private var startScaleY:Number;
		
		public function Mappa()
		{
			initMenu();
			init();
		}
		
		private function init():void
		{
			stage.frameRate=31;
			
			startScaleX=mappa_mc.scaleX;
			startScaleY=mappa_mc.scaleY;
			
			mappa_mc.x=mappa_mc.width/2+30;
			mappa_mc.y=stage.stageHeight/2;
			
			nome_mc.x=stage.stageWidth+10;
			nome_mc.y=stage.stageHeight+10;
			nome_mc.alpha=0;
			
			info_mc.alpha=0;
			info_mc.back_btn.visible=false;
			
			regioni_array=new Array(mappa_mc.aosta_mc,mappa_mc.piemonte_mc,mappa_mc.lombardia_mc,
									mappa_mc.trentino_mc,mappa_mc.friuli_mc,mappa_mc.veneto_mc,
									mappa_mc.liguria_mc,mappa_mc.romagna_mc,mappa_mc.toscana_mc,
									mappa_mc.marche_mc,mappa_mc.umbria_mc,mappa_mc.lazio_mc,
									mappa_mc.campania_mc,mappa_mc.molise_mc,mappa_mc.abruzzo_mc,
									mappa_mc.puglia_mc,mappa_mc.calabria_mc,mappa_mc.basilicata_mc,
									mappa_mc.sicilia_mc,mappa_mc.sardegna_mc);
			info_array=new Array();
			
			loadXML();
		}
		
		private function loadXML():void
		{
			loading_xml=new LoadingXML(this);
		}
		
		public function XmlCaricato():void
		{
			for(var i:int=0;i<regioni_array.length;i++)
			{
				regioni_array[i].id=i;
				regioni_array[i].alpha=.3;
			}
			initListeners();
		}
		
		private function initListeners():void
		{
			for(var i:int=0;i<regioni_array.length;i++)
			{
				regioni_array[i].addEventListener(MouseEvent.MOUSE_OVER,isOver);
				regioni_array[i].addEventListener(MouseEvent.MOUSE_OUT,isOut);
				regioni_array[i].addEventListener(MouseEvent.CLICK,isClick);
			}
		}
		
		private function removeListeners():void
		{
			for(var i:int=0;i<regioni_array.length;i++)
			{
				regioni_array[i].removeEventListener(MouseEvent.MOUSE_OVER,isOver);
				regioni_array[i].removeEventListener(MouseEvent.MOUSE_OUT,isOut);
				regioni_array[i].removeEventListener(MouseEvent.CLICK,isClick);
			}
		}
		
		private function isOver(m:MouseEvent):void
		{
			var mm:*=m.target;
			var mov:MovieClip=mm;
			mappa_mc.swapChildrenAt(mappa_mc.getChildIndex(mov),
									mappa_mc.getChildIndex(regioni_array[regioni_array.length-1]));
			
			m.target.removeEventListener(Event.ENTER_FRAME,sfumaFuori);
			m.target.addEventListener(Event.ENTER_FRAME,sfuma);
			nome_mc.removeEventListener(Event.ENTER_FRAME,nomeFuori);
			nome_mc.addEventListener(Event.ENTER_FRAME,nomeDentro);
			nome_mc.nome_txt.text=info_array[m.currentTarget.id].nome;
			nome_mc.nome_txt.width=nome_mc.nome_txt.textWidth+5;
		}
		
		private function isOut(m:MouseEvent):void
		{
			nome_mc.removeEventListener(Event.ENTER_FRAME,nomeDentro);
			nome_mc.addEventListener(Event.ENTER_FRAME,nomeFuori);
			if(!m.target.isPressed)
			{
				m.target.removeEventListener(Event.ENTER_FRAME,sfuma);
				m.target.addEventListener(Event.ENTER_FRAME,sfumaFuori);
			}
		}
		
		private function isClick(m:MouseEvent):void
		{
			m.target.isPressed=true;
			id=m.currentTarget.id;
			removeListeners();
			for(var i:int=0;i<regioni_array.length;i++)
			{
				if(i!=m.currentTarget.id)
				{
					regioni_array[i].removeEventListener(Event.ENTER_FRAME,sfuma);
					regioni_array[i].removeEventListener(Event.ENTER_FRAME,sfumaFuori);
					regioni_array[i].isPressed=false;
					regioni_array[i].addEventListener(Event.ENTER_FRAME,sfumaFuori);
				}
			}
			m.target.addEventListener(Event.ENTER_FRAME,sfumaTutto);
			nome_mc.removeEventListener(Event.ENTER_FRAME,nomeDentro);
			nome_mc.addEventListener(Event.ENTER_FRAME,nomeFuori);
		}
		
		private function sfuma(e:Event):void
		{
			var da:Number=1-e.target.alpha;
			var aa:Number=da*.2;
			e.target.alpha+=aa;
			
			if(Math.abs(da)<=.02)
			{
				e.target.alpha=1;
				e.target.removeEventListener(Event.ENTER_FRAME,sfuma);
			}
		}
		
		private function sfumaFuori(e:Event):void
		{
			var da:Number=.3-e.target.alpha;
			var aa:Number=da*.2;
			e.target.alpha+=aa;
			
			if(Math.abs(da)<=.02)
			{
				e.target.alpha=.3;
				e.target.removeEventListener(Event.ENTER_FRAME,sfumaFuori);
			}
		}
		
		private function nomeDentro(e:Event):void
		{
			var dnx:Number=(mouseX+10)-e.target.x;
			var anx:Number=dnx*.2;
			e.target.x+=anx;
			
			var dny:Number=(mouseY+10)-e.target.y;
			var any:Number=dny*.2;
			e.target.y+=any;
			
			var dna:Number=1-e.target.alpha;
			var ana:Number=dna*.2;
			e.target.alpha+=ana;
		}
		
		private function nomeFuori(e:Event):void
		{
			var dnx:Number=(stage.stageWidth+10)-e.target.x;
			var anx:Number=dnx*.2;
			e.target.x+=anx;
			
			var dny:Number=(stage.stageHeight+10)-e.target.y;
			var any:Number=dny*.2;
			e.target.y+=any;
			
			var dna:Number=0-e.target.alpha;
			var ana:Number=dna*.2;
			e.target.alpha+=ana;
		}
		
		private function sfumaTutto(e:Event):void
		{
			var arrMappa:Number=.5;
			var dm:Number=arrMappa-mappa_mc.scaleX;
			var am:Number=dm*.2;
			mappa_mc.scaleX+=am;
			mappa_mc.scaleY+=am;
			
			var arrRegione:Number=10;
			var dr:Number=arrRegione-e.target.scaleX;
			var ar:Number=dr*.2;
			e.target.scaleX+=ar;
			e.target.scaleY+=ar;
			if(Math.abs(dm)<=.01)
			{
				mappa_mc.scaleX=mappa_mc.scaleY=arrMappa;
				e.target.scaleX=e.target.scaleY=arrRegione;
				e.target.removeEventListener(Event.ENTER_FRAME,sfumaTutto);
				showInfo();
			}
		}
		
		private function showInfo():void
		{
			info_mc.addEventListener(Event.ENTER_FRAME,showMe);
		}
		
		private function showMe(e:Event):void
		{
			var arrA:Number=1;
			var da:Number=arrA-e.target.alpha;
			var aa:Number=da*.2;
			e.target.alpha+=aa;
			if(Math.abs(da)<=.02)
			{
				e.target.alpha=1;
				e.target.removeEventListener(Event.ENTER_FRAME,showMe);
				displayInfo();
			}
		}
		
		private function displayInfo():void
		{
			for(var i:int=0;i<citta_array[id].length;i++)
			{
				var clip:MovieClip=new MovieClip();
				clip.id=i;
				var tf:TextField=new TextField();
				tf.embedFonts=true;
				tf.defaultTextFormat=getFormat();
				tf.selectable=false;
				tf.multiline=false;
				tf.text=citta_array[id][i].nome;
				tf.width=tf.textWidth+10;
				tf.height=tf.textHeight;
				tf.y=tf.height*i+10*i;
				clip.addChild(tf);
				info_mc.addChild(clip);
				
				clip.mouseChildren=false;
				clip.buttonMode=true;
				clip.addEventListener(MouseEvent.MOUSE_OVER,clipOver);
				clip.addEventListener(MouseEvent.MOUSE_OUT,clipOut);
				clip.addEventListener(MouseEvent.MOUSE_DOWN,clipDown);
			}
			info_mc.back_btn.visible=true;
			info_mc.addEventListener(MouseEvent.CLICK,goBack);
		}
		
		private function clipDown(evt:MouseEvent):void
		{
			var request:URLRequest=new URLRequest(citta_array[id][evt.target.id].link);
			navigateToURL(request,'_blank');
		}
		
		private function clipOut(evt:MouseEvent):void
		{
			var tf:TextField=evt.target.getChildAt(0) as TextField;
			tf.textColor=0x333333;
		}
		
		private function clipOver(evt:MouseEvent):void
		{
			var tf:TextField=evt.target.getChildAt(0) as TextField;
			tf.textColor=0x508FCF;
		}
		
		private function goBack(m:MouseEvent):void
		{
			hideInfo();
			info_mc.addEventListener(Event.ENTER_FRAME,hideMe);
		}
		
		private function hideInfo():void
		{
			
			info_mc.back_btn.visible=false;
		}
		
		private function hideMe(e:Event):void
		{
			var arrA:Number=0;
			var da:Number=arrA-e.target.alpha;
			var aa:Number=da*.2;
			e.target.alpha+=aa;
			if(Math.abs(da)<=.02)
			{
				e.target.alpha=0;
				e.target.removeEventListener(Event.ENTER_FRAME,hideMe);
				mappa_mc.addEventListener(Event.ENTER_FRAME,torna);
			}
		}
		
		private function torna(e:Event):void
		{
			for(var i:int=0;i<info_mc.numChildren;i++)
			{
				if(info_mc.getChildAt(i) is MovieClip)
				{
					var clip:MovieClip=info_mc.getChildAt(i) as MovieClip;
					info_mc.removeChild(clip);
				}
			}
			var arrMappa:Number=1;
			var dmx:Number=startScaleX-e.target.scaleX;
			var amx:Number=dmx*.2;
			var dmy:Number=startScaleY-e.target.scaleY;
			var amy:Number=dmy*.2;
			e.target.scaleX+=amx;
			e.target.scaleY+=amy;
			
			var dm2:Number=1-regioni_array[id].scaleX;
			var am2:Number=dm2*.2;
			regioni_array[id].scaleX+=am2;
			regioni_array[id].scaleY+=am2;
			if(Math.abs(dmx)<=.02)
			{
				e.target.scaleX=startScaleX;
				e.target.scaleY=startScaleY;
				regioni_array[id].scaleX=1;
				regioni_array[id].scaleY=1;
				regioni_array[id].isPressed=false;
				regioni_array[id].alpha=.3;
				e.target.removeEventListener(Event.ENTER_FRAME,torna);
				initListeners();
			}
		}
		
		private function getFormat():TextFormat
		{
			var format:TextFormat=new TextFormat();
			format.font='Arial';
			format.size=14;
			format.color=0x333333;
			return(format);
		}
		
		// NON rimuovere per favore !
		public function initMenu():void
		{
			var etichetta:String='Cartina Italia';
			var cm:ContextMenu=new ContextMenu();
			var item:ContextMenuItem=new ContextMenuItem(etichetta);
			cm.hideBuiltInItems();
			cm.customItems.push(item);
			item.addEventListener(ContextMenuEvent.MENU_ITEM_SELECT,itemHandler1);
			this.contextMenu=cm;
		}
		private function itemHandler1(event:ContextMenuEvent):void
		{
			var url:String='http://www.flepstudio.org/';
			var request:URLRequest=new URLRequest(url);
			navigateToURL(request,'_parent');
		}
	}
}